image: cirrusci/flutter:1.0.0

stages:
  - test
  - coverage
  - test_version

test:stable:
  stage: test
  script:
    - flutter test --coverage
  artifacts:
    paths:
      - coverage


coverage:
  image: registry.gitlab.com/santetis/open_source/santetis_image:latest
  stage: coverage
  coverage: '/^\s+lines.+: (\d+.\d*%)/'
  dependencies:
    - test:stable
  script:
    - genhtml -o coverage coverage/lcov.info

test_version:beta:
  stage: test_version
  script:
    - flutter channel beta && flutter upgrade
    - flutter test

test_version:dev:
  stage: test_version
  script:
    - flutter channel dev && flutter upgrade
    - flutter test

test_version:master:
  stage: test_version
  script:
    - flutter channel master && flutter upgrade
    - flutter test
